const { readFile, writeFile } = require("fs/promises");
const { resolve } = require("path");
const { readdir, stat } = require("fs").promises;

async function getFiles(dir) {
  const subdirs = await readdir(dir);
  const files = await Promise.all(
    subdirs.map(async (subdir) => {
      const res = resolve(dir, subdir);
      return (await stat(res)).isDirectory() ? getFiles(res) : res;
    })
  );
  return files.reduce((a, f) => a.concat(f), []);
}
const REG =
  /^(.+ )?replaceitem entity (\@[aeps]\[.+\]|\@[aeps]) ([^\s]+) (.+)$/;
const processLine = (changed) => (line) => {
  const matches = REG.exec(line);
  if (!matches) return line;
  changed();
  //console.log(matches, matches.length);
  if (matches[1] === undefined)
    return `item replace entity ${matches[2]} ${matches[3]} with ${matches[4]}`;
  else
    return `${matches[1]}item replace entity ${matches[2]} ${matches[3]} with ${matches[4]}`;
};

const line = `replaceitem entity @a[tag=play] armor.feet minecraft:iron_boots{CustomModelData:2,display:{Name:"{\\"text\\":\\"Magnetic Boots\\",\\"italic\\":\\"false\\"}"},HideFlags:1,Unbreakable:1b}`;
console.log(processLine((r) => r)(line));

(async () => {
  const files = (await getFiles(".")).filter((val) =>
    val.endsWith(".mcfunction")
  );
  for (let file of files) {
    const parts = file.split("/");
    console.log("Processing file: " + parts[parts.length - 1]);
    const lines = (await readFile(file, "utf-8"))
      .replace(/\r\n/g, "\n")
      .split("\n");
    let changed = false;
    const change = () => {
      changed = true;
    };
    const process = processLine(change);
    const newLines = lines.map(process);
    if (changed) {
      await writeFile(file, newLines.join("\n"));
      console.log("changed");
    }
  }
})();
